/* $Id: xy_def.h,v 1.8 2003/06/27 13:39:48 berar Exp $ */
/*  xy_def.h common header for winview, gel  */
/* jfberar                                   */
/*-----------------------------------------------------------*/
#ifndef  XY_DEF_H
#define XY_DEF_H
/* pour s'adapter a la machine */
#ifdef __BORLANDC__
#ifndef __WIN32__
#error flat memory is required
#endif
#endif
/*-----------------------------------------------------------*/
#ifndef  PRG_DEF_H
#include "prg_def.h"
#endif
/*-----------------------------------------------------------*/
/*-----------------------------------------------------------*/
#define    FRAMES   INT16U
#define    COUNTS   INT32
#define  T_COUNTS T_INT32
typedef  unsigned char  UCHAR;
typedef  signed   short INT16S;
typedef  unsigned short INT16U;
typedef  int            INT32;
typedef union 
{  INT16U brut;
   struct { unsigned char h,l;}c;
   } SWAP16;
typedef union 
{  INT32 brut;
   INT16U u[2];
   char c[4];
   } SWAP32;
/*-----------------------------------------------------------*/
/* functions used for swapping if necessary                  */
/*-----------------------------------------------------------*/
void xy_setswapon(void);
void xy_setswapoff(void);
extern void (* xy_swap16) (INT16U * brut);
extern void (* xy_swap32) (INT32 * brut);
int  xy_fread16( INT16U* val, long seek, FILE *f);
int  xy_fread32( INT32* val, long seek, FILE *f);
extern int xy_doswap;               /* -1 do, 0 not, 1 ??? */
extern char * xy_swapstring;        /* explicit mode */
void xy_eswap16(INT16U * brut);     /* they are redirected */
void xy_nswap16(INT16U * brut);
void xy_eswap32(INT32 * brut);
void xy_nswap32(INT32 * brut);
/*-----------------------------------------------------------*/
typedef enum { INVALID_IMAGE, T_SPE, T_GEL, T_EDF, T_TIF } T_IMAGE;
typedef enum { INVALID_DATA, T_CHAR, T_INT16, T_INT16U, T_INT32, T_FLOAT, T_ASCII, T_BOOL } T_DATA;
typedef enum { NONE_XYMODE, WV_XYMODE, EDF_XYMODE, GEL_XYMODE, TXT_XYMODE, DMI_XYMODE }  XY_MODE;
typedef  struct
{   float  time;
    float  space;
    float  t_height;
    float  s_height;
    float  ratio;
    INT16U *mval;
    INT16U *mfra;
    double  *sumq;
    int   saturated;
    int   t_number;
    int   s_number;
    int   l_number;
    int   sum_corrected;
    }  COSMIC;
typedef  struct
{   INT16U x, y;
    INT32 z;
    } PIXEL;
typedef struct
{   long  x, y;
    long  size;
    } SIZE;
typedef struct
{   long mini, maxi, nzero, nvalid;
    int x_min, y_min, x_max, y_max;
    double mean, sigma;
    } INFO;
typedef    struct 
{   union { char c[2]; INT16U u;} tag;
    union { char c[2]; INT16U u;} typ;
    union { char c[4]; INT32 l;}  cnt;
    union { char c[4]; INT16U u[2]; INT32 l;} val;
    } TIF_IFD;
typedef    struct 
{   char *key;
    char *string;
    } XY_EDF;
typedef struct
{   INT16U  x_dim, y_dim;
    long    header_end;
    float   expos_sec;
    int     frames;
    T_DATA  t_data;
    T_IMAGE t_image;
    int     edf_disp;
    int     edf_used;
    XY_EDF *edf;
    char   *name;
    FILE   *file;
	 XY_MODE   xy_mode;
    } XY_HDR;
typedef struct
{   int    x_omin, x_omax,  y_omin, y_omax, x_obind, y_obind;
    long   osize,  x_osize, y_osize;
    long   tsize,  x_tsize, y_tsize;
    long   size, x_size, y_size;
    int    beg_frame, end_frame, used_frames;
    char   *xy_orien;
    float  mult;
    char   *name;
    T_DATA t_data;
    INFO   info;
    COUNTS  *data;
    FRAMES *frame;
    XY_HDR *header;
    COSMIC cosmic;
    } IMAGE;
/*-----------------------------------------------------------*/
#define XY_PRINTSIZE     8193     /* max size for dump */
/*-----------------------------------------------------------*/
void     xy_chktype(void);
void     xy_iniuse (void);
int      xy_inipar (IMAGE *img, char* tag, char * arg);
void     xy_setsize(IMAGE *img);
void     xy_prtsize(IMAGE *img);
void     xy_cpsize( IMAGE *img, IMAGE *src );
void     xy_imgini( IMAGE *img, IMAGE *src );
/*-----------------------------------------------------------*/
INT32*   xy16u_bind(IMAGE *img,  INT16U *val);
double   xy16u_min (IMAGE *img, INT16U  *val);
double   xy16u_max (IMAGE *img, INT16U  *val);
double   xy16u_mean (IMAGE *img, INT16U  *val);
double   xy16u_sigma(IMAGE *img, INT16U  *val, double mean);
/*-----------------------------------------------------------*/
INT32*   xy32_bind(IMAGE *img,  INT32 *val);
INT32*   xy32f_bind(IMAGE *img, float *val);
/*-----------------------------------------------------------*/
INT32    xy_valcor(IMAGE *img, int i);
void     xy_orien(IMAGE *img);
void     xy_orien_pixel(IMAGE *img, double *x, double *y, int verbose);
void     xy_info(IMAGE *img, char cas);
/*-----------------------------------------------------------*/
int      xy_edfstr  ( XY_HDR *h, char *key, char *content);
void     xy_puthdr  ( XY_HDR *h, int verbose);
void     xy_putimg  ( IMAGE *i, int verbose);
void     xy_putinfo ( IMAGE *i);
void     xy_fputhdr  ( FILE *f, XY_HDR *h, int verbose);
void     xy_fputinfo( FILE *f, IMAGE *i);
int      xy_chkhdr  ( XY_HDR *h1, XY_HDR *h2);
void     xy_freehdr ( XY_HDR *h);
void     xy_freeimg ( IMAGE *img, int all);
IMAGE *  xy_dupimg  ( IMAGE *img);
/*-----------------------------------------------------------*/
void xy_val_dump( IMAGE * img, FILE * out, char * hdr);
void xy_sum_dump( IMAGE * img, FILE * out, char * hdr);
void xy_sta_dump( IMAGE * img, FILE * out, char * hdr);
/*-----------------------------------------------------------*/
int xy_getrawc (IMAGE *img, unsigned char *val, int pos, FILE *out);
int xy_getrawu (IMAGE *img, INT16U *val, int pos, FILE *out);
int xy_getrawl (IMAGE *img, INT32  *val, int pos, FILE *out);
int xy_getrawf (IMAGE *img, float  *val, int pos, FILE *out);
INT32 *xy_getsum ( IMAGE *img, FILE *out, int print, int do_alloc, int do_stat );
int xy_tcosmic( IMAGE *img, FILE *out );
double xy_vmean( IMAGE *img, int i, int xi, int xf, int yi, int yf, int *n, double *sig2);
double xy_condmean( IMAGE *img, int i, int xi, int xf, int yi, int yf, int *n, float low);
int xy_space( IMAGE *img, FILE *out );
/*-----------------------------------------------------------*/
typedef enum { ADD_IMG, MERGE_IMG } ADD_MERGE;
int xy_rep_name(char *name, IMAGE *img, char *bname, char *ename, 
        int *df, int *iname, int *dont_cor, int *used_frames,
		  ADD_MERGE *rep_mode);
int xy_cur_name(char *buffer, char *path, 
        char *bname, char *ename, int df, int iname);   
		  
/*-----------------------------------------------------------*/
XY_HDR  *xy_open(char *name, char *msg, int quick, char *ext, int real_time, int try_identify); 
/*-----------------------------------------------------------*/
/*-----------------------------------------------------------*/
/* excluded zone xy_excl.c                                   */
/*-----------------------------------------------------------*/
typedef  struct
{   INT16U x1, y1, x2, y2, x3, y3;
    char m, t;     /*  t : 0 point, 1 circle, 2 rectang, 3 triang  + 0x100=roi */ 
    INT32 v;
    char *file_name;
    } ZONE;
#define F_EXCL 0
#define P_EXCL 1
#define C_EXCL 2
#define R_EXCL 3
#define T_EXCL 4
#define ROI    0x10

extern ZONE *excluded;
extern int  n_excluded;
extern int  m_excluded;
/*-----------------------------------------------------------*/
void excl_ini (int excl_type, char *line );
void excl_image ( IMAGE *img, int print);
void excl_save  ( char *line, IMAGE *img);
/*-----------------------------------------------------------*/
/*-----------------------------------------------------------*/
/* grid correction xy_grid.c                                   */
/*-----------------------------------------------------------*/
typedef struct
{  int alloc, size, valid;
   double *xcor, *ycor;
   struct
   {   int ok;
       double gsx, gsy, *value; 
       } tabulated;    /* internal use, reducing time */
   } GRID_COR;
extern GRID_COR grid_cor;  /* initialised structure */
extern char *grid_orig;
int    grid_ini ( GRID_COR *grid, char * tag, char * arg);
void   grid_usage ( void );
void   grid_struct_ini ( GRID_COR *grid, int size);
void   grid_struct_def ( GRID_COR *grid, int size, int xo, int yo);
void   grid_cor_img ( GRID_COR *grid, IMAGE *img, int scale );
char * coef_grid_name(int i);
/* functions using absolute pixel coord */
double grid_pix_surf(double x, double y, GRID_COR *grid);
/* functions using centered pixel coord */
double grid_cor_xpos(double gx, double gy,  GRID_COR *grid);
double grid_cor_ypos(double gx, double gy,  GRID_COR *grid);
double grid_cor_surf(double x, double y, GRID_COR *grid);
double grid_cor_der (int i, double x, double y, GRID_COR *grid);
/* convert absolute to centered coord*/
double grid_pix_xcor(double x, GRID_COR *grid);
double grid_pix_ycor(double y, GRID_COR *grid);
/*-----------------------------------------------------------*/
/* image transformation xy_transfo.c                         */
/*-----------------------------------------------------------*/
void xy_transfo( char * name, IMAGE *img);
/*-----------------------------------------------------------*/
/*-----------------------------------------------------------*/
#endif        /*  XY_DEF_H sentry */
